Index: src/include/device/pci_ids.h
===================================================================
--- src/include/device/pci_ids.h	(revision 2923)
+++ src/include/device/pci_ids.h	(working copy)
@@ -312,11 +312,11 @@
 #define PCI_DEVICE_ID_NS_CS5535_AUDIO	0x002e
 #define PCI_DEVICE_ID_NS_CS5535_USB	0x002f
 #define PCI_DEVICE_ID_NS_CS5535_GX2VGA	0x0030
-#define PCI_DEVICE_ID_NS_SCx200_BRIDGE  0x0500
-#define PCI_DEVICE_ID_NS_SCx200_SMI     0x0501
+#define PCI_DEVICE_ID_NS_SCx200_BRIDGE  0x0500
+#define PCI_DEVICE_ID_NS_SCx200_SMI     0x0501
 #define PCI_DEVICE_ID_NS_SCx200_IDE     0x0502
-#define PCI_DEVICE_ID_NS_SCx200_AUDIO   0x0503
-#define PCI_DEVICE_ID_NS_SCx200_VIDEO   0x0504
+#define PCI_DEVICE_ID_NS_SCx200_AUDIO   0x0503
+#define PCI_DEVICE_ID_NS_SCx200_VIDEO   0x0504
 #define PCI_DEVICE_ID_NS_SCx200_XBUS    0x0505
 #define PCI_DEVICE_ID_NS_87410		0xd001

@@ -652,7 +652,7 @@

 #define PCI_VENDOR_ID_ANIGMA		0x1051
 #define PCI_DEVICE_ID_ANIGMA_MC145575	0x0100
-
+
 #define PCI_VENDOR_ID_EFAR		0x1055
 #define PCI_DEVICE_ID_EFAR_SLC90E66_1	0x9130
 #define PCI_DEVICE_ID_EFAR_SLC90E66_0	0x9460
@@ -1223,7 +1223,7 @@
 #define PCI_DEVICE_ID_EICON_MAESTRAQ	0xe012
 #define PCI_DEVICE_ID_EICON_MAESTRAQ_U	0xe013
 #define PCI_DEVICE_ID_EICON_MAESTRAP	0xe014
-
+
 #define PCI_VENDOR_ID_CYCLONE		0x113c
 #define PCI_DEVICE_ID_CYCLONE_SDK	0x0001

@@ -1726,7 +1726,7 @@
 #define PCI_DEVICE_ID_RASTEL_2PORT	0x2000

 #define PCI_VENDOR_ID_ZOLTRIX		0x15b0
-#define PCI_DEVICE_ID_ZOLTRIX_2BD0	0x2bd0
+#define PCI_DEVICE_ID_ZOLTRIX_2BD0	0x2bd0

 #define PCI_VENDOR_ID_PDC		0x15e9
 #define PCI_DEVICE_ID_PDC_1841		0x1841
@@ -1967,26 +1967,26 @@
 #define PCI_DEVICE_ID_INTEL_PCIE_PC	0x3599

 #define PCI_DEVICE_ID_INTEL_82801DBM_1E0 0x2448
-#define PCI_DEVICE_ID_INTEL_82801DBM_1F0 0x24cc
-#define PCI_DEVICE_ID_INTEL_82801DBM_1F1 0x24ca
-#define PCI_DEVICE_ID_INTEL_82801DBM_1F3 0x24c3
-#define PCI_DEVICE_ID_INTEL_82801DBM_1F5 0x24c5
+#define PCI_DEVICE_ID_INTEL_82801DBM_1F0 0x24cc
+#define PCI_DEVICE_ID_INTEL_82801DBM_1F1 0x24ca
+#define PCI_DEVICE_ID_INTEL_82801DBM_1F3 0x24c3
+#define PCI_DEVICE_ID_INTEL_82801DBM_1F5 0x24c5
 #define PCI_DEVICE_ID_INTEL_82801DBM_1F6 0x24c6
-#define PCI_DEVICE_ID_INTEL_82801DBM_1D0 0x24c2
-#define PCI_DEVICE_ID_INTEL_82801DBM_1D1 0x24c4
+#define PCI_DEVICE_ID_INTEL_82801DBM_1D0 0x24c2
+#define PCI_DEVICE_ID_INTEL_82801DBM_1D1 0x24c4
 #define PCI_DEVICE_ID_INTEL_82801DBM_1D2 0x24c7
 #define PCI_DEVICE_ID_INTEL_82801DBM_1D7 0x24cd

-#define PCI_DEVICE_ID_INTEL_82801ER_1E0 0x244e
-#define PCI_DEVICE_ID_INTEL_82801ER_1F0 0x24d0
-#define PCI_DEVICE_ID_INTEL_82801ER_1F1 0x24db
+#define PCI_DEVICE_ID_INTEL_82801ER_1E0 0x244e
+#define PCI_DEVICE_ID_INTEL_82801ER_1F0 0x24d0
+#define PCI_DEVICE_ID_INTEL_82801ER_1F1 0x24db
 #define PCI_DEVICE_ID_INTEL_82801ER_1F2 0x24d1
-#define PCI_DEVICE_ID_INTEL_82801ER_1F2_R 0x24df
-#define PCI_DEVICE_ID_INTEL_82801ER_1F3 0x24d3
-#define PCI_DEVICE_ID_INTEL_82801ER_1F5 0x24d5
+#define PCI_DEVICE_ID_INTEL_82801ER_1F2_R 0x24df
+#define PCI_DEVICE_ID_INTEL_82801ER_1F3 0x24d3
+#define PCI_DEVICE_ID_INTEL_82801ER_1F5 0x24d5
 #define PCI_DEVICE_ID_INTEL_82801ER_1F6 0x24d6
-#define PCI_DEVICE_ID_INTEL_82801ER_1D0 0x24d2
-#define PCI_DEVICE_ID_INTEL_82801ER_1D1 0x24d4
+#define PCI_DEVICE_ID_INTEL_82801ER_1D0 0x24d2
+#define PCI_DEVICE_ID_INTEL_82801ER_1D1 0x24d4
 #define PCI_DEVICE_ID_INTEL_82801ER_1D2 0x24d7
 #define PCI_DEVICE_ID_INTEL_82801ER_1D3 0x24de
 #define PCI_DEVICE_ID_INTEL_82801ER_1D7 0x24dd
@@ -2076,55 +2076,33 @@
 #define PCI_DEVICE_ID_MICROGATE_SCA	0x0030

 #define PCI_VENDOR_ID_SIS		0x1039
+#define PCI_DEVICE_ID_SIS_AGP 		0x0002
+#define PCI_DEVICE_ID_SIS_SIS761	0x0761
 #define PCI_DEVICE_ID_SIS_SIS966_SB	0x0966
+#define PCI_DEVICE_ID_SIS_SIS966_ISA	0x0966
 #define PCI_DEVICE_ID_SIS_SIS966_LPC	0x0966
-#define PCI_DEVICE_ID_SIS_SIS966_SLAVE	0x0361
-#define PCI_DEVICE_ID_SIS_SIS966_LPC_2	0x0362
-#define PCI_DEVICE_ID_SIS_SIS966_LPC_3	0x0363
-#define PCI_DEVICE_ID_SIS_SIS966_LPC_4	0x0364
-#define PCI_DEVICE_ID_SIS_SIS966_LPC_5	0x0365
-#define PCI_DEVICE_ID_SIS_SIS966_LPC_6	0x0366
-#define PCI_DEVICE_ID_SIS_SIS966_PRO	0x0367
 #define PCI_DEVICE_ID_SIS_SIS966_SM2	0x0368
-#define PCI_DEVICE_ID_SIS_SIS966_IDE	0x5513
-#define PCI_DEVICE_ID_SIS_SIS966_SATA0	0x1183
-#define PCI_DEVICE_ID_SIS_SIS966_SATA1	0x037F
-#define PCI_DEVICE_ID_SIS_SIS966_NIC0	0x190
-#define PCI_DEVICE_ID_SIS_SIS966_NIC1	0x191
-#define PCI_DEVICE_ID_SIS_SIS966_NIC2	0x192
-#define PCI_DEVICE_ID_SIS_SIS966_NIC3	0x193
-#define PCI_DEVICE_ID_SIS_SIS966_NIC_BRIDGE 0x0373
-#define PCI_DEVICE_ID_SIS_SIS966_AZA	0x7502
+#define PCI_DEVICE_ID_SIS_SIS966_HT	0x0369
 #define PCI_DEVICE_ID_SIS_SIS966_PCI	0x0370
+#define PCI_DEVICE_ID_SIS_SIS966_SMB	0x25a4
 #define PCI_DEVICE_ID_SIS_SIS966_PCIE_A_B 0x000A
 #define PCI_DEVICE_ID_SIS_SIS966_PCIE_B_C 0x1002
 #define PCI_DEVICE_ID_SIS_SIS966_PCIE_E	0x1003
 #define PCI_DEVICE_ID_SIS_SIS966_PCIE_A	0x1004
 #define PCI_DEVICE_ID_SIS_SIS966_PCIE_F	0x1005
 #define PCI_DEVICE_ID_SIS_SIS966_PCIE_D	0x1006
-#define PCI_DEVICE_ID_SIS_SIS966_HT	0x0369
-#define PCI_DEVICE_ID_SIS_SIS966_TRIM	0x036A
-#define PCI_DEVICE_ID_SIS_SIS966_PMU	0x036B
-#define PCI_DEVICE_ID_SIS_SIS966_NORTHBRIDGE 0x0756
-#define PCI_DEVICE_ID_SIS_SIS966_ISA	0x0966
 #define PCI_DEVICE_ID_SIS_SIS966_AC97_AUDIO 0x7012
 #define PCI_DEVICE_ID_SIS_SIS966_AC97_MODEM 0x7013
-#define PCI_DEVICE_ID_SIS_SIS966_EHCI	0x7002
 #define PCI_DEVICE_ID_SIS_SIS966_IDE	0x5513
-#define PCI_DEVICE_ID_SIS_SIS966_SMB	0x25a4
+#define PCI_DEVICE_ID_SIS_SIS966_SATA0	0x1183
+#define PCI_DEVICE_ID_SIS_SIS966_NIC0	0x0190
+#define PCI_DEVICE_ID_SIS_SIS966_NIC1	0x0191
+#define PCI_DEVICE_ID_SIS_SIS966_AZA	0x7502
 #define PCI_DEVICE_ID_SIS_SIS966_USB	0x7001
-#define PCI_DEVICE_ID_SIS_SIS966_USB2	0x7001
-#define PCI_DEVICE_ID_SIS_SIS966_USB3	0x7001
-#define PCI_DEVICE_ID_SIS_SIS966_SATA	0x1183
-#define PCI_DEVICE_ID_SIS_SIS966_SATA_R	0x1183
-#define PCI_DEVICE_ID_SIS_SIS966_PIC1	0x25ac
-#define PCI_DEVICE_ID_SIS_SIS966_BRIDGE1C 0x0966
-#define PCI_DEVICE_ID_SIS_AGP 		0x0002
-#define PCI_DEVICE_ID_SIS_SIS761	0x0761
-#define PCI_DEVICE_ID_SIS_SIS756	0x0756
+#define PCI_DEVICE_ID_SIS_SIS966_USB2	0x7002

 /* OLD USAGE FOR LINUXBIOS */
-#define PCI_VENDOR_ID_ACER              0x10b9
+#define PCI_VENDOR_ID_ACER              0x10b9
 #define PCI_DEVICE_ID_ACER_M1535D         0x1533

 #define PCI_DEVICE_ID_AMD_761_0         0x700E
Index: src/mainboard/gigabyte/ga_2761gxdk/cache_as_ram_auto.c
===================================================================
--- src/mainboard/gigabyte/ga_2761gxdk/cache_as_ram_auto.c	(revision 2923)
+++ src/mainboard/gigabyte/ga_2761gxdk/cache_as_ram_auto.c	(working copy)
@@ -46,7 +46,7 @@
 #endif

 #define DBGP_DEFAULT 7
-
+
 #include <stdint.h>
 #include <device/pci_def.h>
 #include <device/pci_ids.h>
@@ -95,7 +95,7 @@

 #include "northbridge/amd/amdk8/setup_resource_map.c"

-#define SERIAL_DEV PNP_DEV(0x2e, IT8716F_SP1)
+#define SERIAL_DEV PNP_DEV(0x2e, IT8716F_SP1)

 #include "southbridge/sis/sis966/sis966_early_ctrl.c"

@@ -126,7 +126,7 @@

 #include "sdram/generic_sdram.c"

-#include "resourcemap.c"
+#include "resourcemap.c"

 #include "cpu/amd/dualcore/dualcore.c"

@@ -171,13 +171,13 @@
         uint8_t byte;

         byte = pci_read_config8(PCI_DEV(0, SIS966_DEVN_BASE+1 , 0), 0x7b);
-        byte |= 0x20;
+        byte |= 0x20;
         pci_write_config8(PCI_DEV(0, SIS966_DEVN_BASE+1 , 0), 0x7b, byte);
-
+
         dword = pci_read_config32(PCI_DEV(0, SIS966_DEVN_BASE+1 , 0), 0xa0);
         dword |= (1<<0);
         pci_write_config32(PCI_DEV(0, SIS966_DEVN_BASE+1 , 0), 0xa0, dword);
-
+
         dword = pci_read_config32(PCI_DEV(0, SIS966_DEVN_BASE+1 , 0), 0xa4);
         dword |= (1<<16);
         pci_write_config32(PCI_DEV(0, SIS966_DEVN_BASE+1 , 0), 0xa4, dword);
@@ -237,15 +237,15 @@

 void cache_as_ram_main(unsigned long bist, unsigned long cpu_init_detectedx)
 {
-#if HAVE_FAILOVER_BOOT==1
+#if HAVE_FAILOVER_BOOT==1
     #if USE_FAILOVER_IMAGE==1
-	failover_process(bist, cpu_init_detectedx);
+	failover_process(bist, cpu_init_detectedx);
     #else
 	real_main(bist, cpu_init_detectedx);
     #endif
 #else
     #if USE_FALLBACK_IMAGE == 1
-	failover_process(bist, cpu_init_detectedx);
+	failover_process(bist, cpu_init_detectedx);
     #endif
 	real_main(bist, cpu_init_detectedx);
 #endif
@@ -281,7 +281,7 @@
         setup_mb_resource_map();

         uart_init();
-
+
 	/* Halt if there was a built in self test failure */
 	report_bist_failure(bist);

@@ -340,7 +340,6 @@

         needs_reset |= optimize_link_coherent_ht();
         needs_reset |= optimize_link_incoherent_ht(sysinfo);
-        needs_reset |= sis966_early_setup_x();

         // fidvid change will issue one LDTSTOP and the HT change will be effective too
         if (needs_reset) {
@@ -353,8 +352,8 @@
 	fill_mem_ctrl(sysinfo->nodes, sysinfo->ctrl, spd_addr);

         sis_init_stage1();
-        enable_smbus();
-
+        enable_smbus();
+
         memreset_setup();

         //do we need apci timer, tsc...., only debug need it for better output
Index: src/mainboard/gigabyte/ga_2761gxdk/chip.h
===================================================================
--- src/mainboard/gigabyte/ga_2761gxdk/chip.h	(revision 2923)
+++ src/mainboard/gigabyte/ga_2761gxdk/chip.h	(working copy)
@@ -1,8 +1,6 @@
 /*
  * This file is part of the LinuxBIOS project.
  *
- * Copyright (C) 2007 AMD
- * Written by Yinghai Lu <yinghailu@amd.com> for AMD.
  * Copyright (C) 2007 Silicon Integrated Systems Corp. (SiS)
  * Written by Morgan Tsai <my_tsai@sis.com> for SiS.
  *
Index: src/mainboard/gigabyte/ga_2761gxdk/Config.lb
===================================================================
--- src/mainboard/gigabyte/ga_2761gxdk/Config.lb	(revision 2923)
+++ src/mainboard/gigabyte/ga_2761gxdk/Config.lb	(working copy)
@@ -239,15 +239,12 @@
 				#  devices on link 0, link 0 == LDT 0
 			        chip southbridge/sis/sis966
 					device pci 0.0 on end   # Northbridge
-					#################################################
-					device pci 1.0 on 			# AGP bridge
+					device pci 1.0 on		# AGP bridge
 					  chip drivers/pci/onboard	# Integrated VGA
 						device pci 0.0 on end
 						register "rom_address" = "0xfff80000"
 					  end
 					end
-					#################################################
-					## device pci 1.0 on end   # PCIE
                 			device pci 2.0 on # LPC
 						chip superio/ite/it8716f
 							device pnp 2e.0 off #  Floppy
@@ -272,12 +269,12 @@
                 	                 			io 0x62 = 0x230
                 	                			irq 0x70 = 9
 							end
-                	        			device pnp 2e.5 off #  Keyboard
+                	        			device pnp 2e.5 on #  Keyboard
                 	                 			io 0x60 = 0x60
                 	                 			io 0x62 = 0x64
                 	                			irq 0x70 = 1
 							end
-                	        			device pnp 2e.6 off #  Mouse
+                	        			device pnp 2e.6 on #  Mouse
                 	                			irq 0x70 = 12
 							end
                 	        			device pnp 2e.8 off #  MIDI
@@ -291,30 +288,27 @@
 						end
 					end

- 					device pci 2.5 on end # IDE (SiS5513)
- 					device pci 2.6 off end # Modem (SiS7013)
- 					device pci 2.7 off end # Audio (SiS7012)
-                			device pci 3.0 on end # USB (SiS7001,USB1.1)
-	                		device pci 3.1 on end # USB (SiS7001,USB1.1)
-	                		device pci 3.3 on end # USB (SiS7002,USB2.0)
-	                		device pci 4.0 on end # NIC (SiS191)
-                			device pci 5.0 on end # SATA (SiS1183)
-                			device pci 6.0 off end # SB PCIE1 (SiS000A)
-                			device pci 7.0 off end # SB PCIE2 (SiS000A)
-        	       			device pci 9.0 off end # PCI E 6
-        	       			device pci a.0 off end # PCI E 5
-        	       			device pci b.0 off end # PCI E 4
-                			device pci c.0 off end # PCI E 3
-                			device pci d.0 off end # PCI E 2
-                			device pci e.0 off end # PCI E 1
-        	       			device pci f.0 on end # Hda
+                                        device pci 2.5 off end # IDE (SiS5513)
+                                        device pci 2.6 off end # Modem (SiS7013)
+                                        device pci 2.7 off end # Audio (SiS7012)
+                                        device pci 3.0 on end # USB (SiS7001,USB1.1)
+                                        device pci 3.1 on end # USB (SiS7001,USB1.1)
+                                        device pci 3.3 on end # USB (SiS7002,USB2.0)
+                                        device pci 4.0 on end # NIC (SiS191)
+                                        device pci 5.0 on end # SATA (SiS1183,IDE Mode)
+                                        device pci 6.0 off end # PCI-E (SiS000A)
+                                        device pci 7.0 off end # PCI-E (SiS000A)
+                                        device pci a.0 off end
+                                        device pci b.0 off end
+                                        device pci c.0 off end
+                                        device pci d.0 off end
+                                        device pci e.0 off end
+                                        device pci f.0 off end # HD Audio (SiS7502)

-	                                register "ide0_enable" = "1"
-	                                register "ide1_enable" = "1"
-                	                register "sata0_enable" = "1"
-                        	        register "sata1_enable" = "1"
-				   	#register "mac_eeprom_smbus" = "3" # 1: smbus under 2e.8, 2: SM0 3: SM1
-				   	#register "mac_eeprom_addr" = "0x51"
+                                        register "ide0_enable" = "1"
+                                        register "ide1_enable" = "1"
+                                        register "sata0_enable" = "1"
+                                        register "sata1_enable" = "1"
 				end
 			end #  device pci 18.0
 			device pci 18.0 on end # Link 1
@@ -328,14 +322,14 @@

 #       chip drivers/generic/debug
 #               device pnp 0.0 off end # chip name
-#                device pnp 0.1 on end # pci_regs_all
-#                device pnp 0.2 on end # mem
-#                device pnp 0.3 off end # cpuid
-#                device pnp 0.4 on end # smbus_regs_all
-#                device pnp 0.5 off end # dual core msr
-#                device pnp 0.6 off end # cache size
+#               device pnp 0.1 on end # pci_regs_all
+#               device pnp 0.2 on end # mem
+#               device pnp 0.3 off end # cpuid
+#               device pnp 0.4 on end # smbus_regs_all
+#               device pnp 0.5 off end # dual core msr
+#               device pnp 0.6 off end # cache size
 #               device pnp 0.7 off end # tsc
-#                device pnp 0.8 off  end # io
-#                device pnp 0.9 off end # io
+#               device pnp 0.8 off  end # io
+#               device pnp 0.9 off end # io
 #       end
 end #root_complex
Index: src/mainboard/gigabyte/ga_2761gxdk/irq_tables.c
===================================================================
--- src/mainboard/gigabyte/ga_2761gxdk/irq_tables.c	(revision 2923)
+++ src/mainboard/gigabyte/ga_2761gxdk/irq_tables.c	(working copy)
@@ -32,7 +32,7 @@
 #include <string.h>
 #include <stdint.h>
 #include <arch/pirq_routing.h>
-
+#include <device/pci_ids.h>
 #include <cpu/amd/amdk8_sysconf.h>

 static void write_pirq_info(struct irq_info *pirq_info, uint8_t bus, uint8_t devfn, uint8_t link0, uint16_t bitmap0,
@@ -75,7 +75,7 @@
         addr &= ~15;

         /* This table must be betweeen 0xf0000 & 0x100000 */
-        printk_info("Writing IRQ routing tables to 0x%x...", addr);
+        printk_info("Writing IRQ routing tables to 0x%x...\n", addr);

 	pirq = (void *)(addr);
 	v = (uint8_t *)(addr);
@@ -88,8 +88,8 @@

 	pirq->exclusive_irqs = 0;

-	pirq->rtr_vendor = 0x10de;
-	pirq->rtr_device = 0x0370;
+	pirq->rtr_vendor = PCI_VENDOR_ID_SIS;
+	pirq->rtr_device = PCI_DEVICE_ID_SIS_SIS966_PCI;

 	pirq->miniport_data = 0;

@@ -124,11 +124,17 @@
                 }

                 printk_debug("Setting Onboard SiS Southbridge\n");
-//                dev = dev_find_slot(0, PCI_DEVFN(2,5));   // 5513 (IDE)
-//                pci_write_config8(dev, 0x3C, 0x0A);
-                dev = dev_find_slot(0, PCI_DEVFN(3,0));   // USB 1.1 -1
+
+                /*
+                 * Non-layout for GA-2761GX
+                 *
+                dev = dev_find_slot(0, PCI_DEVFN(2,5));   // 5513 (IDE)
+                pci_write_config8(dev, 0x3C, 0x0A);
+                */
+
+                dev = dev_find_slot(0, PCI_DEVFN(3,0));   // USB 1.1
                 pci_write_config8(dev, 0x3C, 0x0B);
-                dev = dev_find_slot(0, PCI_DEVFN(3,1));   // USB 1.1 -2
+                dev = dev_find_slot(0, PCI_DEVFN(3,1));   // USB 1.1
                 pci_write_config8(dev, 0x3C, 0x05);
                 dev = dev_find_slot(0, PCI_DEVFN(3,3));   // USB 2.0
                 pci_write_config8(dev, 0x3C, 0x0A);
@@ -136,12 +142,17 @@
                 pci_write_config8(dev, 0x3C, 0x05);
                 dev = dev_find_slot(0, PCI_DEVFN(5,0));    // 1183 (SATA)
                 pci_write_config8(dev, 0x3C, 0x0B);
-//                dev = dev_find_slot(0, PCI_DEVFN(6,0));   // PCI-E
-//                pci_write_config8(dev, 0x3C, 0x0A);
-//                dev = dev_find_slot(0, PCI_DEVFN(7,0));   // PCI-E
-//                pci_write_config8(dev, 0x3C, 0x0A);
+
+                /*
+                 * Non-layout for GA-2761GX
+                 *
+                dev = dev_find_slot(0, PCI_DEVFN(6,0));   // PCI-E
+                pci_write_config8(dev, 0x3C, 0x0A);
+                dev = dev_find_slot(0, PCI_DEVFN(7,0));   // PCI-E
+                pci_write_config8(dev, 0x3C, 0x0A);
                 dev = dev_find_slot(0, PCI_DEVFN(15,0));  // Azalia
                 pci_write_config8(dev, 0x3C, 0x05);
+                */
         }

 //pci bridge
Index: src/mainboard/gigabyte/ga_2761gxdk/mainboard.c
===================================================================
--- src/mainboard/gigabyte/ga_2761gxdk/mainboard.c	(revision 2923)
+++ src/mainboard/gigabyte/ga_2761gxdk/mainboard.c	(working copy)
@@ -1,8 +1,6 @@
 /*
  * This file is part of the LinuxBIOS project.
  *
- * Copyright (C) 2007 AMD
- * Written by Yinghai Lu <yinghailu@amd.com> for AMD.
  * Copyright (C) 2007 Silicon Integrated Systems Corp. (SiS)
  * Written by Morgan Tsai <my_tsai@sis.com> for SiS.
  *
Index: src/mainboard/gigabyte/ga_2761gxdk/Options.lb
===================================================================
--- src/mainboard/gigabyte/ga_2761gxdk/Options.lb	(revision 2923)
+++ src/mainboard/gigabyte/ga_2761gxdk/Options.lb	(working copy)
@@ -1,25 +1,25 @@
-##
+##
 ## This file is part of the LinuxBIOS project.
-##
+##
 ## Copyright (C) 2007 AMD
 ## Written by Yinghai Lu <yinghailu@amd.com> for AMD.
 ## Copyright (C) 2007 Silicon Integrated Systems Corp. (SiS)
 ## Written by Morgan Tsai <my_tsai@sis.com> for SiS.
-##
+##
 ## This program is free software; you can redistribute it and/or modify
 ## it under the terms of the GNU General Public License as published by
 ## the Free Software Foundation; either version 2 of the License, or
 ## (at your option) any later version.
-##
+##
 ## This program is distributed in the hope that it will be useful,
 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ## GNU General Public License for more details.
-##
+##
 ## You should have received a copy of the GNU General Public License
 ## along with this program; if not, write to the Free Software
 ## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
-##
+##

 uses HAVE_MP_TABLE
 uses HAVE_PIRQ_TABLE
@@ -197,7 +197,7 @@
 #CHIP_NAME ?
 default CONFIG_CHIP_NAME=1

-#memory hole size, 0 mean disable, others will enable the hole, at that case if it is small than mmio_basek, it will use mmio_basek instead.
+#memory hole size, 0 mean disable, others will enable the hole, at that case if it is small than mmio_basek, it will use mmio_basek instead.
 #2G
 #default HW_MEM_HOLE_SIZEK=0x200000
 #1G
@@ -253,8 +253,8 @@
 ##
 ## Clean up the motherboard id strings
 ##
-default MAINBOARD_PART_NUMBER="SiS"
-default MAINBOARD_VENDOR="SIS"
+default MAINBOARD_PART_NUMBER="ga_2761gxdk"
+default MAINBOARD_VENDOR="GIGABYTE"
 default MAINBOARD_PCI_SUBSYSTEM_VENDOR_ID=0x1039
 default MAINBOARD_PCI_SUBSYSTEM_DEVICE_ID=0x1234

@@ -294,7 +294,7 @@

 ###
 ### Defaults of options that you may want to override in the target config file
-###
+###

 ##
 ## The default compiler
@@ -304,7 +304,7 @@

 ##
 ## Disable the gdb stub by default
-##
+##
 default CONFIG_GDB_STUB=0

 ##
@@ -335,15 +335,15 @@
 ##
 ### Select the linuxBIOS loglevel
 ##
-## EMERG      1   system is unusable
-## ALERT      2   action must be taken immediately
-## CRIT       3   critical conditions
-## ERR        4   error conditions
-## WARNING    5   warning conditions
-## NOTICE     6   normal but significant condition
-## INFO       7   informational
-## DEBUG      8   debug-level messages
-## SPEW       9   Way too many details
+## EMERG      1   system is unusable
+## ALERT      2   action must be taken immediately
+## CRIT       3   critical conditions
+## ERR        4   error conditions
+## WARNING    5   warning conditions
+## NOTICE     6   normal but significant condition
+## INFO       7   informational
+## DEBUG      8   debug-level messages
+## SPEW       9   Way too many details

 ## Request this level of debugging output
 default  DEFAULT_CONSOLE_LOGLEVEL=8
Index: src/southbridge/sis/sis966/chip.h
===================================================================
--- src/southbridge/sis/sis966/chip.h	(revision 2923)
+++ src/southbridge/sis/sis966/chip.h	(working copy)
@@ -1,8 +1,6 @@
 /*
  * This file is part of the LinuxBIOS project.
  *
- * Copyright (C) 2007 AMD
- * Written by Yinghai Lu <yinghai.lu@amd.com> for AMD.
  * Copyright (C) 2007 Silicon Integrated Systems Corp. (SiS)
  * Written by Morgan Tsai <my_tsai@sis.com> for SiS.
  *
Index: src/southbridge/sis/sis966/Config.lb
===================================================================
--- src/southbridge/sis/sis966/Config.lb	(revision 2923)
+++ src/southbridge/sis/sis966/Config.lb	(working copy)
@@ -1,27 +1,26 @@
-##
+##
 ## This file is part of the LinuxBIOS project.
-##
+##
 ## Copyright (C) 2007 Silicon Integrated Systems Corp. (SiS)
 ## Written by Morgan Tsai <my_tsai@sis.com> for SiS.
-##
+##
 ## This program is free software; you can redistribute it and/or modify
 ## it under the terms of the GNU General Public License as published by
 ## the Free Software Foundation; either version 2 of the License, or
 ## (at your option) any later version.
-##
+##
 ## This program is distributed in the hope that it will be useful,
 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ## GNU General Public License for more details.
-##
+##
 ## You should have received a copy of the GNU General Public License
 ## along with this program; if not, write to the Free Software
 ## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
-##
+##

 config chip.h
-#driver sis_agp.o
-driver sisnb.o
+driver sis761.o
 driver sis966.o
 driver sis966_usb.o
 driver sis966_lpc.o
Index: src/southbridge/sis/sis966/romstrap.inc
===================================================================
--- src/southbridge/sis/sis966/romstrap.inc	(revision 2923)
+++ src/southbridge/sis/sis966/romstrap.inc	(working copy)
@@ -43,29 +43,17 @@
 	.long 0xFFFFFFFF			// 28h
 	.long 0xFFFFFFFF			// 2Ch

-// MAC address -------------------------------- 0x7FFC0h
 	.long 0x56341200			// 30h, MAC address low 4 byte ---> keep it in 0xffffffc0
 	.long 0x00009078			// 34h, MAC address high 4 byte

 	.long 0x002309CE			// 38h, UUID low 4 byte
 	.long 0x00E08100			// 3Ch, UUID high 4 byte

+	.long 0x00402000			//Firmware trap for SiS761+966
+	.long 0xE043A800
+	.long 0x00180000
+	.long 0x1421C402

-// Firmware Trap --------------------------------  0x7FFD0h
-/*
-//Firmware trap for SiS761+966
-        .long 0x00402000
-        .long 0x6043A800
-        .long 0x00180000
-        .long 0x1421C402
-*/
-
-//Firmware trap for SiS756+966              ---> keep it in 0xffffffd0
-        .long 0x00402000
-        .long 0xE043A800
-        .long 0x00180000
-        .long 0x1421C402
-
 rspointers:
 	.long rstables				// It will be 0xffffffe0
 	.long rstables
Index: src/southbridge/sis/sis966/sis761.c
===================================================================
--- src/southbridge/sis/sis966/sis761.c	(revision 0)
+++ src/southbridge/sis/sis966/sis761.c	(revision 0)
@@ -0,0 +1,191 @@
+/*
+ * This file is part of the LinuxBIOS project.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ *
+ * Turn off machine check triggers when reading
+ * pci space where there are no devices.
+ * This is necessary when scaning the bus for
+ * devices which is done by the kernel
+ *
+ * written in 2003 by Eric Biederman
+ *
+ *  - Athlon64 workarounds by Stefan Reinauer
+ *  - "reset once" logic by Yinghai Lu
+ * Copyright (C) 2007 Silicon Integrated Systems Corp. (SiS)
+ * Written by Morgan Tsai <my_tsai@sis.com> for SiS.
+ *
+ */
+
+#include <console/console.h>
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+#include <part/hard_reset.h>
+#include <pc80/mc146818rtc.h>
+#include <bitops.h>
+#include <cpu/amd/model_fxx_rev.h>
+
+//#include "amdk8.h"
+
+#include <arch/io.h>
+
+/**
+ * @brief Read resources for AGP aperture
+ *
+ * @param
+ *
+ * There is only one AGP aperture resource needed. The resoruce is added to
+ * the northbridge of BSP.
+ *
+ * The same trick can be used to augment legacy VGA resources which can
+ * be detect by generic pci reousrce allocator for VGA devices.
+ * BAD: it is more tricky than I think, the resource allocation code is
+ * implemented in a way to NOT DOING legacy VGA resource allcation on
+ * purpose :-(.
+ */
+
+
+typedef struct msr_struct
+{
+	unsigned lo;
+	unsigned hi;
+} msr_t;
+
+static inline msr_t rdmsr(unsigned index)
+{
+	msr_t result;
+	result.lo = 0;
+	result.hi = 0;
+	return result;
+}
+
+
+
+static void sis761_read_resources(device_t dev)
+{
+	struct resource *resource;
+	unsigned char iommu;
+	/* Read the generic PCI resources */
+	printk_debug("sis761_read_resources\n");
+	pci_dev_read_resources(dev);
+
+	/* If we are not the first processor don't allocate the gart apeture */
+	if (dev->path.u.pci.devfn != PCI_DEVFN(0x0, 0)) {
+		return;
+	}
+
+
+	return;
+
+	iommu = 1;
+	get_option(&iommu, "iommu");
+
+	if (iommu) {
+		/* Add a Gart apeture resource */
+		resource = new_resource(dev, 0x94);
+		resource->size = iommu?AGP_APERTURE_SIZE:1;
+		resource->align = log2(resource->size);
+		resource->gran  = log2(resource->size);
+		resource->limit = 0xffffffff; /* 4G */
+		resource->flags = IORESOURCE_MEM;
+	}
+}
+
+static void set_agp_aperture(device_t dev)
+{
+	struct resource *resource;
+
+	return;
+
+	resource = probe_resource(dev, 0x94);
+	if (resource) {
+		device_t pdev;
+		uint32_t gart_base, gart_acr;
+
+		/* Remember this resource has been stored */
+		resource->flags |= IORESOURCE_STORED;
+
+		/* Find the size of the GART aperture */
+		gart_acr = (0<<6)|(0<<5)|(0<<4)|((resource->gran - 25) << 1)|(0<<0);
+
+		/* Get the base address */
+		gart_base = ((resource->base) >> 25) & 0x00007fff;
+
+		/* Update the other northbriges */
+		pdev = 0;
+		while((pdev = dev_find_device(PCI_VENDOR_ID_AMD, 0x1103, pdev))) {
+			/* Store the GART size but don't enable it */
+			pci_write_config32(pdev, 0x90, gart_acr);
+
+			/* Store the GART base address */
+			pci_write_config32(pdev, 0x94, gart_base);
+
+			/* Don't set the GART Table base address */
+			pci_write_config32(pdev, 0x98, 0);
+
+			/* Report the resource has been stored... */
+			report_resource_stored(pdev, resource, " <gart>");
+		}
+	}
+}
+
+static void sis761_set_resources(device_t dev)
+{
+        printk_debug("sis761_set_resources ------->\n");
+	/* Set the gart apeture */
+//	set_agp_aperture(dev);
+
+	/* Set the generic PCI resources */
+	pci_dev_set_resources(dev);
+	printk_debug("sis761_set_resources <-------\n");
+}
+
+static void sis761_init(struct device *dev)
+{
+	uint32_t cmd, cmd_ref;
+	int needs_reset;
+	struct device *f0_dev, *f2_dev;
+	msr_t	msr;
+
+
+	needs_reset = 0;
+	printk_debug("sis761_init: ---------->\n");
+
+	msr = rdmsr(0xC001001A);
+	pci_write_config16(dev, 0x8E, msr.lo >> 16);				// Topbound
+	pci_write_config8(dev, 0x7F, 0x08);			// ACPI Base
+	outb(inb(0x856) | 0x40, 0x856);	 // Auto-Reset Function
+
+	printk_debug("sis761_init: <----------\n");
+	printk_debug("done.\n");
+}
+
+
+static struct device_operations sis761_ops  = {
+	.read_resources   = sis761_read_resources,
+	.set_resources    = sis761_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init             = sis761_init,
+	.scan_bus         = 0,
+	.ops_pci          = 0,
+};
+
+static const struct pci_driver sis761_driver __pci_driver = {
+	.ops    = &sis761_ops,
+	.vendor = PCI_VENDOR_ID_SIS,
+	.device = PCI_DEVICE_ID_SIS_SIS761,
+};
